;==================================================
; MzPlasm
; Author: Simone Portuesi, Giorgio Scorzelli
; DATE: January 2007
;==================================================


(define *USE_GEOMETRY* #t)     ; to disable C++ wrapper
(define *DEBUG* '())                      ; to show debug messages
(define *FREE-UNUSED-MEMORY* #f)          ; to automatically gargabe collecting
(define *DO-UNPRUNE* #f)                  ; used internally for BSPs
(define *PLASMLIBSDIR* "psmlib")          ; directory for libraries
; Optimization:
; LIST - use scheme list instead of PLASM - Should not break anything
; APPLY - remove passage through Plasm apply - Breaks animation
; LAMBDA - use scheme lambda for PLASM DEFS -  May break param/local visibility 
; LOCAL - use scheme letrec for locals - May break param/local visibility 
; PREBIND - try to prebind FENVS variable at Syntax level - May break locals redef on these variables
; PREBING_AGR - Prebind FENVS variable at Syntax level - Breaks Libs ... so IT IS dangerous, now is not active until user intraction
; PREBIND2 - Prebind second version, needs local and lambda but is safer
(define *OPT* '( LIST LAMBDA LOCAL PREBIND2)) 
;(define *OPT* '( LIST APPLY)) 
         
; Per Stefano (NON ME LO TOCCARE!!!!)
(define *RET_VAL* #f)                     ; to always show scheme return value

(define (plasm-exception arg) 
  (display "uncaught exception: " )(display arg)(newline))

(display "Loading file.ss...")
(require (lib "file.ss")) 
(display "done")
(newline)

(display "Loading pretty.ss... ")
(require (lib "pretty.ss"))
(display "done")
(newline)

(display "Loading string.ss... ")
(require (lib "string.ss"))
(display "done")
(newline)

(display "Loading url.ss... ")
(require (lib  "url.ss" "net"))
(display "done")
(newline)

(display "Loading class.ss... ")
(require (lib "class.ss"))
(display "done")
(newline)

(display "Loading list.ss... ")
(require (lib "list.ss"))
(display "done")
(newline)

(define (plasm arg)
 ; (time (Plasm_Parser arg)))
  (hpc-benchmark-reset)
  (let ((res  (time (Plasm_Parser arg))))
    (newline)
    (display "PLaSM #object: ") (display (hpc-count))(newline)
    (display "HPC time: ")(display (hpc-benchmark-time))(newline) 
    (display "HPC + PLaSM time: ")(display  (hpc-benchmark-gross-time))(newline)
 ;   (display "PLaSM/HPC benchmark log: ")(display (hpc-benchmark-log #f))(newline)
    (newline)
    res))

(define (plasm-adoc arg) (Plasm_Parser arg #f #t))

(define (eval_plasm arg) (plasm arg))
(define (eval-plasm arg) (plasm arg)) 

(define (1+ aint) (+ 1 aint))
(define (1- aint) (- aint 1))


(display (string-append "Loading " "plt" (version) ".scm" "...")) (newline)
(load/use-compiled  (string-append "plt" (version) ".scm"))
(display "done") 
(newline)

(display "Loading matrix.scm... ") (newline)
(load/use-compiled "matrix.scm")
(display "done") 
(newline)

(display "Loading Syntax_Rules.scm... ") (newline)
(load/use-compiled "Syntax_Rules.scm")
(display "done") 
(newline)

(display "Loading Fmap.scm")
(load/use-compiled "Fmap.scm")
(display "done") 
(newline)

(display "Loading Printer.scm... ")
(load/use-compiled  "Printer.scm")
(display "done") 
(newline)

(display "Loading env.scm... ")
(load/use-compiled "env.scm")
(display "done") 

(newline)
(display "Loading Properties.scm... ")
(load/use-compiled "Properties.scm")
(display "done") 
(newline)

(display "Loading f_envs.scm... ")
(load/use-compiled "f_envs.scm")
(display "done") 
(newline)


(display "Loading PlasmAnim.scm")
(load/use-compiled  "PlasmAnim.scm")
(display "done") 
(newline)


(display "Loading remote_plasm.scm... ")
(load/use-compiled  "remote_plasm.scm")
(display "done") 
(newline)


; --------------------------------------------------
; insert here the loading of user-defined libraries 
; warning: symbols are not protected
; --------------------------------------------------

(loadlib "variables")
;(set! *DEBUG* '())                      ; to show debug messages



;(welcome (current-output-port))
(newline)
